EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_SPOTLIGHT_MANAGER_EVENT_POS_UPDATE =
   EFL_EVENT_DESCRIPTION("pos_update");
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_manager_bind, EFL_FUNC_CALL(spotlight), Efl_Ui_Spotlight_Container *spotlight);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_manager_content_add, EFL_FUNC_CALL(subobj, index), Efl_Gfx_Entity *subobj, int index);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_manager_content_del, EFL_FUNC_CALL(subobj, index), Efl_Gfx_Entity *subobj, int index);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_manager_switch_to, EFL_FUNC_CALL(from, to, reason), int from, int to, Efl_Ui_Spotlight_Manager_Switch_Reason reason);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_manager_size_set, EFL_FUNC_CALL(size), Eina_Size2D size);

static Eina_Error
__eolian_efl_ui_spotlight_manager_animated_transition_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_spotlight_manager_animated_transition_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_manager_animated_transition_set, EFL_FUNC_CALL(enable), Eina_Bool enable);

static Eina_Value
__eolian_efl_ui_spotlight_manager_animated_transition_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_spotlight_manager_animated_transition_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_spotlight_manager_animated_transition_get, Eina_Bool, 0);

static Eina_Bool
_efl_ui_spotlight_manager_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_SPOTLIGHT_MANAGER_EXTRA_OPS
#define EFL_UI_SPOTLIGHT_MANAGER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_bind, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_content_add, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_content_del, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_switch_to, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_size_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_animated_transition_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_animated_transition_get, NULL),
      EFL_UI_SPOTLIGHT_MANAGER_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"animated_transition", __eolian_efl_ui_spotlight_manager_animated_transition_set_reflect, __eolian_efl_ui_spotlight_manager_animated_transition_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_spotlight_manager_class_desc = {
   EO_VERSION,
   "Efl.Ui.Spotlight.Manager",
   EFL_CLASS_TYPE_REGULAR_NO_INSTANT,
   sizeof(Efl_Ui_Spotlight_Manager_Data),
   _efl_ui_spotlight_manager_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_spotlight_manager_class_get, &_efl_ui_spotlight_manager_class_desc, EFL_OBJECT_CLASS, NULL);
